'#####################################################
'Mit OLE einen Link anlegen
'#####################################################
'Andreas Miethe * Juli 2002
'#####################################################

'Definitionen
DEF MultiByteToWideChar(6) ! "Kernel32","MultiByteToWideChar"
DEF CoInitialize(1)        ! "OLE32","CoInitialize"
DEF CoUnInitialize(0)      ! "OLE32","CoUninitialize"
DEF CoCreateInstance(5)    ! "OLE32","CoCreateInstance"

'Konstanten
DEF &PShell_Release     8
DEF &PShell_SetDescription 28
DEF &PShell_SetWorkingDirectory 36
DEF &PShell_SetArguments 44
DEF &PShell_SetIconLocation 68
DEF &PShell_SetPath 80
DEF &PFile_Release 8
DEF &PFile_Save 24

'globale Variablen
Declare CLSID_IShellLink#
Declare IID_IShellLink#
Declare IID_IPersistFile#

Proc CreateLink
Declare Pshell&,PFile&,Command&
Declare LinkFile$
Declare WideFile$
Parameters LinkFile$,TargetFile$,Description$,WorkingDirectory$,Arguments$,IconFile$,IconNo&

Dim CLSID_IShellLink#,16
Long CLSID_IShellLink#,0 = $00021401
Word CLSID_IShellLink#,4 = $0000
Word CLSID_IShellLink#,6 = $0000
Byte CLSID_IShellLink#,8 = $C0
Byte CLSID_IShellLink#,9 = $00
Byte CLSID_IShellLink#,10 = $00
Byte CLSID_IShellLink#,11 = $00
Byte CLSID_IShellLink#,12 = $00
Byte CLSID_IShellLink#,13 = $00
Byte CLSID_IShellLink#,14 = $00
Byte CLSID_IShellLink#,15 = $46
'
Dim IID_IShellLink#,16
Long IID_IShellLink#,0 = $000214EE
Word IID_IShellLink#,4 = $0000
Word IID_IShellLink#,6 = $0000
Byte IID_IShellLink#,8 = $C0
Byte IID_IShellLink#,9 = $00
Byte IID_IShellLink#,10 = $00
Byte IID_IShellLink#,11 = $00
Byte IID_IShellLink#,12 = $00
Byte IID_IShellLink#,13 = $00
Byte IID_IShellLink#,14 = $00
Byte IID_IShellLink#,15 = $46
'
Dim IID_IPersistFile#,16
Long IID_IPersistFile#,0 = $0000010b
Word IID_IPersistFile#,4 = $0000
Word IID_IPersistFile#,6 = $0000
Byte IID_IPersistFile#,8 = $C0
Byte IID_IPersistFile#,9 = $00
Byte IID_IPersistFile#,10 = $00
Byte IID_IPersistFile#,11 = $00
Byte IID_IPersistFile#,12 = $00
Byte IID_IPersistFile#,13 = $00
Byte IID_IPersistFile#,14 = $00
Byte IID_IPersistFile#,15 = $46
'
CoInitialize(0)
CoCreateInstance(CLSID_IShellLink#,0,1,IID_IShellLink#,Addr(PShell&))
Command& = Long(Pshell&,0)
CALL(LONG(COMMAND&,0),PShell&,IID_IPersistFile#,Addr(PFile&))'QueryInterface ermitteln
CALL(LONG(COMMAND&,&PShell_SetPath),PShell&,Addr(TargetFile$))'Datei
CALL(LONG(COMMAND&,&PShell_SetDescription),PShell&,Addr(Description$))'Beschreibung
CALL(LONG(COMMAND&,&PShell_SetWorkingDirectory),PShell&,Addr(WorkingDirectory$))'Arbeits-Ordner
CALL(LONG(COMMAND&,&PShell_SetArguments),PShell&,Addr(Arguments$))'Argumentenliste
CALL(LONG(COMMAND&,&PShell_SetIconLocation),PShell&,Addr(IconFile$),IconNo&)'IconLocation
WideFile$ = Space$(Len(LinkFile$)*2)
MultiByteToWideChar(0,1,addr(LinkFile$),-1,addr(WideFile$),Len(WideFile$))'LinkFile umwandeln
Command& = Long(PFile&,0)
CALL(LONG(COMMAND&,&PFile_Save),PFile&,Addr(WideFile$),1)'LinkFile speichern
Command& = Long(PShell&,0)
CALL(LONG(COMMAND&,&PShell_Release),PShell&)
Command& = Long(PFile&,0)
CALL(LONG(COMMAND&,&PFile_Release),PFile&)
CoUnInitialize()
Dispose CLSID_IShellLink#
Dispose IID_IShellLink#
Dispose IID_IPersistFile#
EndProc
